namespace Telerik.Reporting.Examples.CSharp
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;
    using Telerik.Reporting;
    using Telerik.Reporting.Drawing;

    /// <summary>
    /// Summary description for Report6.
    /// </summary>
    public partial class InteractiveSortingSampleReport : Telerik.Reporting.Report
    {
        public InteractiveSortingSampleReport()
        {
            /// <summary>
            /// Required for telerik Reporting designer support
            /// </summary>
            InitializeComponent();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        public static object SetSortingDirection(Processing.ReportItem dataItem)
        {
            Sorting sorting;
            var dataItemDefinition = (Telerik.Reporting.Table)dataItem.ItemDefinition;

            if ((bool)dataItem.Report.Parameters["IsGroupSorting"].Value == true)
            {
                //The name of the group to be sorted should match the value of the SortBy parameter.
                var groupName = ((string)dataItem.Report.Parameters["SortBy"].Value).ToLowerInvariant();

                sorting = FindGroupByName(dataItemDefinition.RowGroups, groupName).Sortings[0];
            }
            else
            {
                sorting = dataItemDefinition.Sortings[0];
            }

            if (((string)dataItem.Report.Parameters["SortDirection"].Value) == "Descending")
            {
                sorting.Direction = Telerik.Reporting.SortDirection.Desc;
            }
            else
            {
                sorting.Direction = Telerik.Reporting.SortDirection.Asc;
            }

            return dataItemDefinition.DataSource;
        }

        public static string ToggleSortDirection(Telerik.Reporting.Processing.ReportItem reportItem, string sortBy)
        {
            var currentSortBy = (string)reportItem.Report.Parameters["SortBy"].Value;
            var currentSortDirection = (string)reportItem.Report.Parameters["SortDirection"].Value;

            if (currentSortBy != sortBy)
            {
                return "Ascending";
            }

            if (currentSortDirection == "Descending")
            {
                return "Ascending";
            }
            else
            {
                return "Descending";
            }
        }

        static TableGroup FindGroupByName(IList<TableGroup> tableGroups, string groupName)
        {
            TableGroup group = null;

            foreach (var tg in tableGroups)
            {
                if (tg.Name.ToLowerInvariant() == groupName)
                {
                    group = tg;
                }
                else
                {
                    group = FindGroupByName(tg.ChildGroups, groupName);
                }
            }

            return group;
        }
    }
}